#ifndef _DBGCHECK_H
#define _DBGCHECK_H


#if defined( WIN32 ) && defined( TUNE )
	#include <crtdbg.h>
	_CrtMemState startMemState;
	_CrtMemState endMemState;
#endif

#include <iostream>   //ShowXml()ȿ 

#include <crtdbg.h>

#ifdef _DEBUG 
#define new			new(_CLIENT_BLOCK, __FILE__, __LINE__) 

#ifdef  malloc
#undef	malloc
#endif
#define malloc(s)	(_malloc_dbg( s, _NORMAL_BLOCK, __FILE__, __LINE__ ))

#ifdef  calloc
#undef  calloc
#endif
#define calloc(c, s)  (_calloc_dbg(c, s, _NORMAL_BLOCK, __FILE__, __LINE__ ))

#ifdef  realloc
#undef  realloc
#endif
#define realloc(p, s)  (_realloc_dbg(p, s, _NORMAL_BLOCK, __FILE__, __LINE__ ))

#ifdef  _expand
#undef  _expand
#endif
#define _expand(p, s)  (_expand_dbg(p, s, _NORMAL_BLOCK, __FILE__, __LINE__ ))

#ifdef  free
#undef  undef  free
#endif
#define free(p)         (_free_dbg(p, _NORMAL_BLOCK ))

#ifdef  _msize
#undef  _msize
#endif  
#define _msize(p)        (_msize_dbg(p, _NORMAL_BLOCK ))

#endif 

void StartDebug() 
{ 
	_CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF | _CRTDBG_ALLOC_MEM_DF); 
} 


#endif